import { CompletionContext, CompletionResult } from "@codemirror/autocomplete";
import { JSONSchema7 } from "json-schema";
export declare const TOKENS: {
    STRING: string;
    NUMBER: string;
    TRUE: string;
    FALSE: string;
    NULL: string;
    OBJECT: string;
    ARRAY: string;
    PROPERTY: string;
    PROPERTY_NAME: string;
    JSON_TEXT: string;
    INVALID: string;
};
export declare const VALUE_TYPES: string[];
export declare class JSONCompletion {
    private schema;
    constructor(schema: JSONSchema7);
    doComplete(ctx: CompletionContext): CompletionResult;
    private getPropertyCompletions;
    private getInsertTextForProperty;
    private getInsertTextForGuessedValue;
    private getInsertTextForPlainText;
    private getInsertTextForValue;
    private getValueCompletions;
    private addSchemaValueCompletions;
    private addDefaultValueCompletions;
    private addEnumValueCompletions;
    private addBooleanValueCompletion;
    private addNullValueCompletion;
    private collectTypes;
    private getArrayNodeChildren;
    private findNodeIndexInArrayNode;
    private getSchemas;
    private getSchemasForNodes;
    private expandSchemaProperty;
    private getReferenceSchema;
    private getWord;
    private getChildrenNodes;
    private getChildValueNode;
    private isValueNode;
    private isPropertyNameNode;
    private getLabelForValue;
    private getValueFromLabel;
    private extendedRegExp;
    private stripSurrondingQuotes;
}
/**
 * provides a JSON schema enabled autocomplete extension for codemirror
 * @group Codemirror Extensions
 */
export declare function jsonCompletion(schema: JSONSchema7): (ctx: CompletionContext) => CompletionResult;
