import { EditorState, Text } from "@codemirror/state";
import { SyntaxNode } from "@lezer/common";
import { JSONPointersMap, Side } from "../types";
export type JSONMode = "json4" | "json5";
/**
 * get a JSON4/5 pointer for a given node in the editor
 *
 * adapted from https://discuss.codemirror.net/t/json-pointer-at-cursor-seeking-implementation-critique/4793/3
 * this could be useful for other things later!
 * @group Utilities
 * @internal
 */
export declare function getJsonPointerAt(docText: Text, node: SyntaxNode, mode?: JSONMode): string;
/**
 * retrieve a JSON pointer for a given position in the editor
 * @group Utilities
 */
export declare const jsonPointerForPosition: (state: EditorState, pos: number, side: Side, mode?: JSONMode) => string;
/**
 * retrieve a Map of all the json pointers in a document
 * @group Utilities
 */
export declare const getJsonPointers: (state: EditorState, mode?: JSONMode) => JSONPointersMap;
